#!/usr/bin/ruby
# coding: utf-8
require "cgi"
require 'yaml'

file_yaml   = "paramexp-cgi.yml"
file_cgitop = "paramexp-cgi_cgitop.txt"
file_cgibot = "paramexp-cgi_cgibot.txt"

def put_message( line )
  put_header
  print line, "\n"
  print "<br>"
  put_footer
end
def put_header
  print <<~EOD
  Content-type: text/html; charset=utf-8

  <html lang="ja">
  <head>
    <meta charset="utf-8">
    <!--
    <meta http-equiv="cache-control" content="private">
    -->
    <title>Parameter experiments</title>
  </head>
  <body>
  EOD
end
def put_footer
  print <<~EOD
    </body>
    </html>
  EOD
end

yml_input = YAML.load_file( file_yaml )

flag_debug     = yml_input["flag_debug"]
flag_show_info = yml_input["flag_show_info"]
flag_dirlink   = yml_input["flag_dirlink"]


dir_prefix  = yml_input["dir_prefix"]


params_name          = yml_input["parameters"].keys

#params_name          = ["RotPeriod", "Obl", "Radius"]
#param_rotperiod_val  = [1, 3, 10, 30, 90]
#param_rotperiod_unit = "Earth days"
#param_obl_val        = [0.0, 23.4, 60.0, 90.0]
#param_obl_unit       = "degrees"
#param_radius_val     = [6371, 4247, 3186]
#param_radius_unit    = "km"


in_hash = CGI.new


fixed_params_val = Array.new( params_name.size )
for i in 0..(params_name.size-1)
  fixed_params_val[i] = in_hash[ params_name[i] ]
end



file_fig         = in_hash[ "variable" ]
param_axis1_name = in_hash[ "param_axis1" ]
param_axis2_name = in_hash[ "param_axis2" ]
fig_width        = in_hash[ "fig_width" ]

if param_axis1_name == param_axis2_name then
  put_header
  print "Error: axis1 has to be different from axis2."
  put_footer
  print "<br>"
  exit
end

param_axis1_long_name = yml_input["parameters"][param_axis1_name]["long_name"]
param_axis1_unit      = yml_input["parameters"][param_axis1_name]["unit"]
param_axis1_vals      = yml_input["parameters"][param_axis1_name]["values"]
param_axis1_format    = yml_input["parameters"][param_axis1_name]["label_format"]
#
param_axis2_long_name = yml_input["parameters"][param_axis2_name]["long_name"]
param_axis2_unit      = yml_input["parameters"][param_axis2_name]["unit"]
param_axis2_vals      = yml_input["parameters"][param_axis2_name]["values"]
param_axis2_format    = yml_input["parameters"][param_axis2_name]["label_format"]


#put_header
#for i in 0..(params_name.size-1)
#  print params_name[i], ":", fixed_params_val[i], "\n"
#  print "<br>"
#end
#print param_axis1_name, ":", param_axis1_vals, "\n"
#print "<br>"
#print param_axis2_name, ":", param_axis2_vals, "\n"
#print "<br>"
#put_footer
#exit


# file path
fixed_param_strings = Array.new( params_name.size )
for i in 0..(params_name.size-1)
  name         = params_name[i]
  label_format = yml_input["parameters"][name]["label_format"]
  label        = sprintf( label_format, fixed_params_val[i] )
  fixed_param_strings[i] = name + label
end


fig_paths = Array.new( param_axis2_vals.size ).map{ Array.new( param_axis1_vals.size ) }
param_strings = Array.new( params_name.size )
param_strings = fixed_param_strings
for j in 0..(param_axis2_vals.size-1)
  label = sprintf( param_axis2_format, param_axis2_vals[j] )
  param_axis2_string = param_axis2_name + label
  for k in 0..(params_name.size-1)
    if params_name[k] == param_axis2_name then
      param_strings[k] = param_axis2_string
    end
  end

  for i in 0..(param_axis1_vals.size-1)
    label = sprintf( param_axis1_format, param_axis1_vals[i] )
    param_axis1_string = param_axis1_name + label
    for k in 0..(params_name.size-1)
      if params_name[k] == param_axis1_name then
        param_strings[k] = param_axis1_string
      end
    end

    string = param_strings[0]
    for k in (0+1)..(params_name.size-1)
      string = string + "_" + param_strings[k]
    end

    dir = dir_prefix + string
    fig_path = dir + "/" + file_fig
    fig_paths[j][i] = fig_path
  end
end


put_header

#print "This is a test page for cgi.", "\n"


#print "Figure path:", "<br>", "\n"
#for j in 0..(fig_paths[0].size-1)
#  for i in 0..(fig_paths.size-1)
#    print "  [", i, "][", j, "] ", fig_paths[j][i], "\n"
#    print "<br>", "\n"
#  end
#end


if File.exist?( file_cgitop ) then
  f = File.open( file_cgitop, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

print "<table border=1>", "\n"

# param values
#print "  <td rowspan=", param_axis2_vals.size, ">", "\n"
#print "    ", param_axis2_name, "\n"
#print "  </td>", "\n"

#   1st line
print "<tr>", "\n"
print "  <td colspan=2 rowspan=2>", "\n"
print "  </td>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
print '  <td colspan=', param_axis1_vals.size, ' align=center>', "\n"
if param_axis1_unit == "" then
  print "    ", param_axis1_long_name, "<br>", "\n"
else
  print "    ", param_axis1_long_name, "<br>", "(", param_axis1_unit, ")", "\n"
end
print "  </td>", "\n"
print "</tr>", "\n"
#   2nd line
print "<tr>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
#print "  <td>", "\n"
#print "  </td>", "\n"
for i in 0..(param_axis1_vals.size-1)
  print "  <td align=center>", "\n"
  print "    ", param_axis1_vals[i], "\n"
  print "  </td>", "\n"
end
print "</tr>", "\n"

#   3rd, 4th, ... lines
for j in 0..(param_axis2_vals.size-1)

  print "<tr>", "\n"

  if j == 0 then
    print "  <td rowspan=", param_axis2_vals.size, " align=center>", "\n"
    if param_axis2_unit == "" then
      print "    ", param_axis2_long_name, "<br>", "\n"
    else
      print "    ", param_axis2_long_name, "<br>", "(", param_axis2_unit, ")", "\n"
    end
    print "  </td>", "\n"
  end

  print "  <td align=center>", "\n"
  print "    ", param_axis2_vals[j], "\n"
  print "  </td>", "\n"

  for i in 0..(param_axis1_vals.size-1)

    fig_path = fig_paths[j][i]

    print '  <td align="center">', "\n"
    if File.exist?(fig_path) then
      if File.extname(fig_path) == ".mp4" then
        print '    <video controls src="', fig_path, '" width=', fig_width, '></video>', "\n"
      else
        print '    <img src="', fig_path, '" width=', fig_width, 'alt="" title="">', "\n"
      end
      if flag_dirlink then
        print "<br>"
        print "\n"
        print '    <a href="', fig_path[0..fig_path.rindex("/")-1], '">[directory]</a>', "\n"
        print "\n"
      end
    else
      print '    No figure', "\n"
    end
    # debug
    if flag_debug then
      print '    ', fig_path, "\n"
    end
    #
    print '  </td>', "\n"
  end
  print "</tr>", "\n"

end

print "</table>", "\n"


if flag_show_info then

  print "<br>", "\n"
  print "<br>", "\n"

  #print "=======================", "\n"
  #print "<br>", "\n"
  print "<hr>", "\n"

  print "Figure file : ", file_fig, "\n"
  print "<br>", "\n"

  print "<br>", "\n"

  for i in 0..(params_name.size-1)
    print "Parameter ", i, " : ", params_name[i], "=", fixed_params_val[i], "\n"
    print "<br>", "\n"
  end

  print "<br>", "\n"

  print "Column : ", param_axis1_name, "\n"
  print "<br>", "\n"
  print "Row    : ", param_axis2_name, "\n"
  print "<br>", "\n"

  print "<br>", "\n"

  print "Figure width : ", fig_width, "\n"
  print "<br>", "\n"

  #print "=======================", "\n"
  #print "<br>", "\n"
  print "<hr>", "\n"

end

if File.exist?( file_cgibot ) then
  f = File.open( file_cgibot, "r" )
  lines = f.read  # 全て読み込む
  f.close
  print lines
end

put_footer

